package player;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTextArea;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * The Info class displays legal information.
 * @author Martin Henke
 *
 */
public class Info extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private final JPanel contentPanel = new JPanel();
	private JTextArea txtrThisProgramHas;
	private JButton okButton;

	/**
	 * Initializes the dialog.
	 */
	public Info() {
		setTitle("About MP3Player");
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		txtrThisProgramHas = new JTextArea();
		txtrThisProgramHas.setFont(new Font("SansSerif", Font.PLAIN, 11));
		txtrThisProgramHas.setLineWrap(true);
		txtrThisProgramHas.setEditable(false);
		txtrThisProgramHas.setWrapStyleWord(true);
		txtrThisProgramHas.setText("This program has been written by Martin Henke and can be freely used or modified.");
		txtrThisProgramHas.setBounds(10, 11, 422, 217);
		contentPanel.add(txtrThisProgramHas);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				okButton = new JButton("OK");
				okButton.addActionListener(this);
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
		}
	}
	/**
	 * Handles clicks.
	 * @param e The associated ActionEvent object.
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == okButton) {
			okButtonActionPerformed(e);
		}
	}
	/**
	 * Closes the dialog.
	 * @param e The associated ActionEvent object.
	 */
	protected void okButtonActionPerformed(ActionEvent e) {
		this.setVisible(false);
	}
}
