package editor;

import javax.swing.table.AbstractTableModel;

/**
 * The class EmptyTableModel inherits from AbstractTableModel and provides column names and the return values to display an empty table.
 * @author Martin Henke
 *
 */
public class EmptyTableModel extends AbstractTableModel {
	
	private static final long serialVersionUID = 7628422146898896566L;
	
	private static String[] columns = {"Name", "Value"};	// Holds the column names

	/**
	 * Returns the number of rows (always 0).
	 */
	@Override
	public int getRowCount() {
		return 0;
	}

	/**
	 * Returns the number of columns.
	 */
	@Override
	public int getColumnCount() {
		return columns.length;
	}
	
	/**
	 * Returns the column name for the specified column.
	 */
	@Override
	public String getColumnName(int column){
		return columns[column];
	}	

	/**
	 * Returns the value for the specified row and column (always null).
	 */
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		return null;
	}
}
