package fontRelated;

import javax.swing.AbstractListModel;

/**
 * The class FontSizeListModel inherits from AbstractListModel<Integer> and contains a list of Integer values between 5 and 99.
 * @author Martin Henke
 *
 */
public class FontSizeListModel extends AbstractListModel<Integer> {
	// Since this is just a plain list of Integer values, the value can be calculated each time it is requested.
	private static final long serialVersionUID = 9205979934517829376L;
	
	/**
	 * Gets the number of sizes.
	 */
	@Override
	public int getSize() {
		return 94;
	}

	/**
	 * Get the Integer value for the specified index. Since this is a plain list, we just need to add the minimum value to the specified index.
	 */
	@Override
	public Integer getElementAt(int index) {
		return index + 5;
	}

}
