package panels;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import configuration.Font;
import fontRelated.*;

/**
 * The class FontPanel inherits from JPanel and provides the functionality to choose a font.
 * @author Martin
 *
 */
public class FontPanel extends JPanel implements ActionListener {

	private static final long serialVersionUID = -4406629948020329172L;
	
	private JLabel lblFontName;
	private JLabel lblName;
	private JLabel lblFontSize;
	private JLabel lblSize;
	private JLabel lblFontStyle;
	private JLabel lblStyle;
	private JButton btnChoose;
	private JLabel lblSampleText;
	private JLabel lblSampleText1;
	private JLabel lblSampleText2;
	
	/**
	 * Initializes the panel.
	 */
	public FontPanel(){
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		lblFontName = new JLabel("Name");
		lblFontName.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblFontName = new GridBagConstraints();
		gbc_lblFontName.insets = new Insets(0, 0, 5, 5);
		gbc_lblFontName.anchor = GridBagConstraints.WEST;
		gbc_lblFontName.gridx = 0;
		gbc_lblFontName.gridy = 0;
		add(lblFontName, gbc_lblFontName);
		
		lblName = new JLabel("");
		lblName.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblName = new GridBagConstraints();
		gbc_lblName.insets = new Insets(0, 0, 5, 5);
		gbc_lblName.anchor = GridBagConstraints.WEST;
		gbc_lblName.gridx = 1;
		gbc_lblName.gridy = 0;
		add(lblName, gbc_lblName);
		
		lblFontSize = new JLabel("Size");
		lblFontSize.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblFontSize = new GridBagConstraints();
		gbc_lblFontSize.anchor = GridBagConstraints.WEST;
		gbc_lblFontSize.insets = new Insets(0, 0, 5, 5);
		gbc_lblFontSize.gridx = 0;
		gbc_lblFontSize.gridy = 1;
		add(lblFontSize, gbc_lblFontSize);
		
		lblSize = new JLabel("");
		lblSize.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblSize = new GridBagConstraints();
		gbc_lblSize.anchor = GridBagConstraints.WEST;
		gbc_lblSize.insets = new Insets(0, 0, 5, 5);
		gbc_lblSize.gridx = 1;
		gbc_lblSize.gridy = 1;
		add(lblSize, gbc_lblSize);
		
		btnChoose = new JButton("Choose");
		btnChoose.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		btnChoose.addActionListener(this);
		GridBagConstraints gbc_btnChoose = new GridBagConstraints();
		gbc_btnChoose.anchor = GridBagConstraints.WEST;
		gbc_btnChoose.insets = new Insets(0, 0, 5, 0);
		gbc_btnChoose.gridx = 3;
		gbc_btnChoose.gridy = 1;
		add(btnChoose, gbc_btnChoose);
		
		lblFontStyle = new JLabel("Style");
		lblFontStyle.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblFontStyle = new GridBagConstraints();
		gbc_lblFontStyle.insets = new Insets(0, 0, 5, 5);
		gbc_lblFontStyle.gridx = 0;
		gbc_lblFontStyle.gridy = 2;
		add(lblFontStyle, gbc_lblFontStyle);
		
		lblStyle = new JLabel("");
		lblStyle.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblStyle = new GridBagConstraints();
		gbc_lblStyle.anchor = GridBagConstraints.WEST;
		gbc_lblStyle.insets = new Insets(0, 0, 5, 5);
		gbc_lblStyle.gridx = 1;
		gbc_lblStyle.gridy = 2;
		add(lblStyle, gbc_lblStyle);
		
		lblSampleText = new JLabel("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
		lblSampleText.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblSampleText = new GridBagConstraints();
		gbc_lblSampleText.insets = new Insets(0, 0, 5, 0);
		gbc_lblSampleText.anchor = GridBagConstraints.WEST;
		gbc_lblSampleText.gridwidth = 4;
		gbc_lblSampleText.gridx = 0;
		gbc_lblSampleText.gridy = 4;
		add(lblSampleText, gbc_lblSampleText);
		
		lblSampleText1 = new JLabel("abcdefghijklmnopqrstuvwxyz");
		lblSampleText1.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblSampleText1 = new GridBagConstraints();
		gbc_lblSampleText1.anchor = GridBagConstraints.WEST;
		gbc_lblSampleText1.gridwidth = 4;
		gbc_lblSampleText1.insets = new Insets(0, 0, 5, 0);
		gbc_lblSampleText1.gridx = 0;
		gbc_lblSampleText1.gridy = 5;
		add(lblSampleText1, gbc_lblSampleText1);
		
		lblSampleText2 = new JLabel("1234567890,;.:-_!\"\u00A7$%&/()=?#'+*");
		lblSampleText2.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 11));
		GridBagConstraints gbc_lblSampleText2 = new GridBagConstraints();
		gbc_lblSampleText2.insets = new Insets(0, 0, 5, 0);
		gbc_lblSampleText2.gridwidth = 4;
		gbc_lblSampleText2.anchor = GridBagConstraints.WEST;
		gbc_lblSampleText2.gridx = 0;
		gbc_lblSampleText2.gridy = 6;
		add(lblSampleText2, gbc_lblSampleText2);
	}
	
	/**
	 * Gets the selected font.
	 * @return The selected font.
	 */
	public Font getValue() {
		return new Font(this.lblSampleText.getFont());
	}
	/**
	 * Sets the font.
	 * @param value The font to set.
	 */
	public void setValue(Font value){
		setValue(value.toFont());
	}
	/**
	 * Sets the font.
	 * @param value The font to set.
	 */
	private void setValue(java.awt.Font value){
		this.lblName.setText(value.getFamily());
		this.lblSize.setText(String.valueOf(value.getSize()));
		this.lblStyle.setText(FontStyleListModel.getFormatString(value));		
		this.lblSampleText.setFont(value);
		this.lblSampleText1.setFont(value);
		this.lblSampleText2.setFont(value);				
	}
	/**
	 * Handles clicks. 
	 * @param e The associated ActionEvent object.
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.btnChoose) {
			btnChooseActionPerformed(e);
		}
	}
	/**
	 * Opens the JFontChooser dialog and sets the font.
	 * @param e The associated ActionEvent object.
	 */
	protected void btnChooseActionPerformed(ActionEvent e) {
		JFontChooser fontChooser = new JFontChooser("Please choose a Font", lblSampleText.getFont());
		if (fontChooser.showDialog() == JFileChooser.APPROVE_OPTION){
			setValue(fontChooser.getFont());
			fontChooser.dispose();
		} else if (fontChooser != null){
			fontChooser.dispose();
		}
	}
}
