package configuration;

import javax.xml.bind.annotation.XmlElement;

/**
 * The class TextControl extends <code>Control</code> and allows XML serialization of the settings for the controls with text displayed by MP3Player.
 *  
 * @author Martin Henke
 *
 */
public class TextControl extends Control {
	
	private static final long serialVersionUID = 4428577004736969091L;

	private String text = "";
	
	/**
	 * The empty constructor is required for XML serialization and should not be used in your code.
	 */
	public TextControl(){ }
	
	/**
	 * The constructor allows to specify this name as a parameter.
	 * @param name The name of this object.
	 */
	public TextControl(String name){
		super(name);
	}

	/**
	 * Gets the text.
	 * @return The text.
	 */
	public String getText() { return text; }
	/**
	 * Sets the text.
	 * @param text The text.
	 */
	@XmlElement(name = "Text", required = true)
	public void setText(String text) { this.text = text; }
}
