package generic;

import java.net.URI;
import java.net.URISyntaxException;

/**
 * The Helper class holds static helper functions.
 * @author Martin Henke
 *
 */
public class Helper {
	private static String jarDirectory = null;
	static {
		jarDirectory = getJarDirectory();
	}
	/**
	 * Gets the path to the directory in which the application is located.
	 * @return The path to the directory in which the application is located.
	 */
	public static String getJarDirectory(){
		if (jarDirectory == null){
			jarDirectory = Helper.class.getProtectionDomain().getCodeSource().getLocation().getPath();
			try {
				jarDirectory = new URI(jarDirectory).getPath();
			} catch (URISyntaxException e) { }
		}
		return jarDirectory;
	}
}
